
	/*------------------------------------------------------------------------------	
	*		Project:
	*			Trinidad & Tobago Data Harmonization
	* 		Created: 	 May 10, 2017
	*		Last update: May 10, 2017
	* ------------------------------------------------------------------------------			

	** PURPOSE: 	This do file checks the value added results. Coefficient of 1 should be obtained in a full compliance scenario.
					
	** INPUTS:     	Stack databases

	** OUTPUTS:  

	* ----------------------------------------------------------------------------*/




*global a "z1"
	global csec "y1 y5 y10"
	global cape "z1 z11 z9"

	
	*Years for which program is going to be executed 
	local all_years ="0 1988 1989 1990 1991 1992 1993 1994 1995 1996 1997 1998 1999 2000 2001 2002 2003 2004 2005 2006 2007 2008 2009 2010 2011"
	local current_years = "0 1988 1989 1990 1991 1992 1993 1994 1995 1996 1997 1998 1999 2000 2001 2002 2003 2004 2005 2006 2007 2008 2009 2010 2011"

	
		
local va = "att"
local sch = "att"
local comply = "no_comply"

				
				
				local comb=0
				if "`va'"=="sim" & "`sch'"=="sim" & "`comply'"=="no_comply" local comb=1
				if "`va'"=="att" & "`sch'"=="sim" & "`comply'"=="no_comply" local comb=2
				if "`va'"=="sim" & "`sch'"=="att" & "`comply'"=="no_comply" local comb=3
				if "`va'"=="att" & "`sch'"=="att" & "`comply'"=="no_comply" local comb=4
				if "`va'"=="sim" & "`sch'"=="att" & "`comply'"=="comply_att_reg" local comb=5
				
				
				if (`comb'!=4) continue
				/*
				if "`va'" == "sim" {
					continue //Temporary. We want to estimate att in this run. Take out after. ###
					}
				*/
				
				/*
				if ("`va'" != "sim" | "`sch'" != "att" ) & "`comply'" != "no_comply" {
					continue //In the case of att we are only interested in the no comply version.
					}
				*/	
				foreach i in $csec $cape {
										
					cd "$z"

					*Stack Database using scores
					use  id_bssee bssee_cohort schoolcode cutoff_total_conv allocation_simulation above in_sch1 rco* using "$in_diether\BSSEE_CSEC_CAPE_BARBADOS_applicants_reduced.dta", clear
					
												
					merge m:1 id_bssee bssee_cohort using "$in_diether/summary_stats.dta", keep(match) nogen keepusing(female schattended allocation_simulation parish_g total_conv std_bssee c?)
					merge m:1 id_bssee bssee_cohort using "$in_diether/summary_stats.dta", keep(match) nogen keepusing(`i')

					
										*****************************
										******** For Testing ********
					*keep if schoolcode<3
					*keep if bssee_cohort == 2009 | bssee_cohort==2008
					
						
						/*
										gen u=runiform()
										sort u
										keep if _n<200000
										*/
										*****************************
										*****************************

					*STEP 1: Merge Simulated Value added for School Attended	
					rename schoolcode temp
					rename schattended schoolcode	
					
					merge m:1 bssee_cohort schoolcode using "$in_diether\ValueAddeds_Factors", keep(match) nogen keepusing(oos_`va'_fe`i')

					rename schoolcode schattended
					rename temp schoolcode	
							
									
					*STEP 2: Define variables:
						*above
						*Already in dbase
										
						*Define other variables
					*Polynomial of score and relative score and interactions	
					gen std_bssee_2=std_bssee*std_bssee
					gen std_bssee_3=std_bssee*std_bssee*std_bssee
					gen std_bssee_4=std_bssee*std_bssee*std_bssee*std_bssee
					gen std_bssee_5=std_bssee*std_bssee*std_bssee*std_bssee*std_bssee
					
					*Interactions of score on above
					gen std_bsseei=above*std_bssee
					gen std_bssee_2i=above*std_bssee_2
					gen std_bssee_3i=above*std_bssee_3
											
						*Cutoffs (For Fixed effects)
					egen choice_year = group(schoolcode bssee_cohort)
					*egen cut_diff=group(choice_year d)
					*egen choiceset=group(c1 c2 c3 c4 c5 c6 c7 c8 c9) , missing

					capture label var choice_year "Unique group for each Cutoff: preferred school + year"
					capture label var choiceset "Unique group for each Choiceset"
					*label var cut_diff "Unique group for preferred school + next preferred school + year"
					capture estimates drop *

					*STEP 3: Regressions on outcomes and value addeds

					keep `i' id_bssee bssee_cohort schoolcode schattended allocation_simulation std_bssee std_bssee* above in_sch1 rco* female parish_g oos_*fe`i' choice_year

					compress
						
					save "$in_diether\TEMP_`i'.dta", replace	
					
				
					*With oos fixed effects (all years pooled)
					if _N>1 {
						use "$in_diether\TEMP_`i'.dta", clear
						egen ismissing = rowmiss(`i' oos_*fe`i' above std_bssee std_bssee* rco* female parish_g)
						drop if ismissing>0
						levelsof schoolcode, local(schoollist_`i')
						foreach s in `schoollist_`i'' {
							preserve
							keep if schoolcode==`s' //
							di "Outcome: `i' / School: `s'"
							if _N>1 {
								*Regression on outcome	
									
									*With individual controls: sex, religion, district & (5th order polynomial)
									reghdfe `i' above female  std_bssee std_bssee_?, absorb(parish_g) cluster(id_bssee rco)
									*estimates store e9_`i'_`s'
									matrix A = r(table)
									local oos_N_`i'_0_`s'_9 = e(N)
									local oos_b_`i'_0_`s'_9 = A[1,1]
									local oos_t_`i'_0_`s'_9 = A[3,1]
									local oos_pv_`i'_0_`s'_9 = A[4,1]
									
									*With individual controls: sex, religion, district & (5th order polynomial)
									reghdfe oos_`va'_fe`i' above female  std_bssee std_bssee_?, absorb(parish_g) cluster(id_bssee rco)
									*estimates store e19_`i'_`s'
									matrix A = r(table)
									local oos_N_`i'_0_`s'_19 = e(N)
									local oos_b_`i'_0_`s'_19 = A[1,1]
									local oos_t_`i'_0_`s'_19 = A[3,1]
									local oos_pv_`i'_0_`s'_19 = A[4,1]

								}
							restore
							}
						}
				
					}
					
					
				clear
				capture set obs 99999
				local cont=1
				gen year = .
				gen i = ""
				gen s = .
				gen type = ""

				foreach n in "9" "19" {
					gen b_`n'= .
					gen t_`n'=.
					gen pv_`n'=.
					gen N_`n'=.
					}
						
				
	

				local year=0
				foreach i in $csec $cape {
					foreach s in `schoollist_`i'' {
					
						replace year = `year' in `cont'
						replace i = "`i'" in `cont'
						replace s = `s' in `cont'
						replace type = "Out of sample" in `cont'

						foreach n in "9" "19" {
							capture replace b_`n' = `oos_b_`i'_`year'_`s'_`n'' in `cont'
							capture replace pv_`n' = `oos_pv_`i'_`year'_`s'_`n'' in `cont'
							capture replace t_`n' = `oos_t_`i'_`year'_`s'_`n'' in `cont'
							capture replace N_`n' = `oos_N_`i'_`year'_`s'_`n'' in `cont'
							}
						local cont = `cont' + 1
						}	
					} 

				
				save "$in_diether\coefs_Factors_SCH`sch'_VA`va'_`comply'", replace
		