*Validation Graph

	


*With attended school
local va "att"
local sch "att"
local comply "no_comply"

*Selected RD definitions
local on_out = 9
local on_fe = 19
			
	use "$in_diether\coefs_Factors_SCH`sch'_VA`va'_`comply'.dta", clear
				
	keep if type=="Out of sample" & year==0

	bysort i: egen m_`on_out'=mean(b_`on_out')
	bysort i: egen sd_`on_out'=sd(b_`on_out')
	bysort i: egen m_`on_fe'=mean(b_`on_fe')
	bysort i: egen sd_`on_fe'=sd(b_`on_fe')
		
	egen i_group=group(i)

	*Weights by outcome
	bysort i: gen count=_N
	gen weight2=1/count
	 

	******************************************************************

	*Center around zero
	bysort i: egen m_`on_out'a=mean(b_`on_out')
	bysort i: egen m_`on_fe'a=mean(b_`on_fe')

	replace b_`on_out'=b_`on_out'-m_`on_out'a
	replace b_`on_fe'=b_`on_fe'-m_`on_fe'a
			
			
	foreach group in "CSEC" /*"CAPE" "y1" "y5" "y10" "z1" "z9" "z11" "all"*/ { 
		preserve
		
			local min 0
			local max 0
			
			
			*local group "CSEC" 
			*if "`group'"=="all"
			if "`group'"=="CSEC" 	keep if i=="y1" | i=="y5" | i=="y10"
			if "`group'"=="CAPE" 	keep if i=="z1" | i=="z11" | i=="z9"
			if ("`group'"=="y1" | "`group'"=="y5" | "`group'"=="y10" | "`group'"=="z1" | "`group'"=="z9" | "`group'"=="z11") keep if i=="`group'"
			
			
			if "`group'"=="all"		local title = "Cutoff Effects on Actual Outcomes vs. Predicted Impacts"
			if "`group'"=="CSEC" 	local title = "CSEC Outcomes"
			if "`group'"=="CAPE" 	local title = "CAPE Outcomes"
			if "`group'"=="y1" 		local title = "Took CSEC"
			if "`group'"=="y5"		local title = "# CSEC Subjects approved within 5+ years of BSSEE" 
			if "`group'"=="y10" 	local title = "CSEC Approved 5 subjects (including Mathematics and English A)"
			if "`group'"=="z1"		local title = "Took CAPE"
			if "`group'"=="z9" 		local title = "Associate degree"
			if "`group'"=="z11"		local title = "# CAPE 2-Unit Subjects approved (I-V)"

			reghdfe b_`on_out' b_`on_fe' [weight=weight2], a(i_group)  cluster(s)
			matrix A = r(table)
			local slope: display %5.2f A[1,1]
			
			test b_`on_fe'==1
			local pval1: display %5.3f r(p)
						
			test b_`on_fe'==0
			local pval0: display %5.3f r(p)
			
			if "`sch'"=="att" local tit "Attended"
			if "`sch'"=="sim" local tit "Simulated"
			if "`comply'"=="comply_att_reg" local adj " - Compliance Adjusted"
			
			sum b_`on_out'
			
			/*
			local step 0.05
			if r(max)-r(min)>.3 local step 0.1
			if r(max)-r(min)> 1 local step 0.2
			if r(max)-r(min)> 1.5 local step 0.4
			
			
			di "`step'"
			
			local min: display %5.1f	round(r(min)-`step',`step')
			local max: display %5.1f 	round(r(max)+`step',`step')
			
			di "`max'"
			di "`min'"
			*/
			
			local step=0.5
			local min=-.5
			local max=1
		
			twoway (scatter b_`on_out' b_`on_fe',   msize(large) msymbol(oh) mcolor(gs8)) (lfit b_`on_out' b_`on_fe' [aweight = weight2], lcolor(black) lwidth(thick)) (lfit b_`on_out' b_`on_out', lpatter(-) lcolor(gs8)), ///
				xtitle("Cutoff Effect on Value-Added of `tit' School`adj'") ///
				xlabel(`min'(`step')`max') ///
				ytitle("Cutoff Effect on Actual Outcome") ///
				ylabel(`min'(`step')`max') ///
				subtitle("`title'") ///
				legend(col(3) lab(1 "Cutoff Effects") lab(2 "Linear Fit") lab(3 "45° Line")) ///
				graphregion(color(white)) ///
				note("                    Slope = `slope' : (Slope == 0 : pval -> `pval0'; Slope == 1 : pval -> `pval1')")
			graph save Graph "$out\SCH`sch'_VA`va'_`comply'_`group'_nodrop.gph" , replace		
			capture qui graph export "$out\SCH`sch'_VA`va'_`comply'_`group'_nodrop.png", replace	
		restore
	}

