* ANALYSIS OF EFFECTS SIZES TO PRODUCE A META-ANALYSIS OF EDUCATIONAL INTERVENTIONS.
* IT USES A PROCEDURE SIMILAR TO THE ONE USED IN THE SKILLSBANK (AS OF 20-FEB-2019).
* THERE ARE 3 DO FILES INVOLVED IN THIS ANALYSIS. 


* THIS IS THE FIRST DO FILE.
* THIS DO FILE, CALLED PREPARE.DO, PREPARE THE DATA SETS THAT CONTAINS INFORMATION AT THE EFFECT- AND EVALUATION-LEVELS.



clear all
set more off





* I. ARRANGE EFFECTS-LEVEL DATA 

 
import excel "$z/Dataset.xlsx", sheet("8. Effects") firstrow clear


//No effects
gen mark = 0
replace mark=1 if Effectsize==. | SE==.

replace Effectsize=Beta_nst  	if Effectsize==.
replace SE=SE_nst				if SE==.

//temporary
keep Effectsize SE Outcome PaperID N CountryCity EvaluationName Concatenate EffectID Grades Population FollowupID ITT1yes Effectsize SE mark exclude
 
rename Effectsize coef
rename SE se
rename CountryCity country

drop if PaperID == . 

destring coef se, replace


rename Outcome eff
gen outcome = .

*High School
replace outcome = 1 if eff	=="Math" | eff=="Math (SAT)" | eff == "Math on high" | eff == "Math on middle" | eff =="SSCE Math (secondary certification)" | eff=="Woodcock Johnson Math" | eff=="Algebra" //High school exam math
replace outcome = 2 if eff 	=="Reading" | eff=="Chinese" | eff=="Verbal" | eff=="Verbal (SAT)" | eff == "Woodcock Johnson Reading" | eff=="ELA" | eff=="English" | eff=="English on high" | eff=="English on middle" | eff=="Language" | eff=="SSCE English (secondary certification)" //High school exam reading
replace outcome = 3 if eff 	== "Math+Reading" | eff=="test scores (math, english, swahili)" | eff == "Score 11 grade" | eff=="Score 9 grade" | eff=="SAT score (average)" | eff=="Combined score" | eff=="Combined excluding hindi" | eff=="SEEC"  //High school exam math+reading
replace outcome = 3 if eff == "College entrance exam score (math + chinese + OTHERS)" | eff == "college entrance score" | eff == "Baccalaureate grade" //College exam
replace outcome = 5 if eff 	== "Graduated" | eff=="HS graduation" | eff=="Graduated HS" | eff=="Graduated from any secondary school" | eff == "CMS Graduate" //Graduated high school
replace outcome = 6 if eff 	== "Dropped out" //Dropped out
replace outcome = 7 if eff 	== "Take SSCE (secondary certification)" | eff=="taking CSEC" | eff=="Probability SAT (average)" | eff=="Baccalaureate taken" | eff=="Took SAT" //Take secondary certification
replace outcome = 8 if eff 	== "# exams passed" //# of exam passed in secondary certificate
replace outcome = 9 if eff 	== "earning certificate" //Earning secondary certificate

*College

replace outcome = 21 if eff == "College Enrollment" | eff == "Enrollment in college" //College enrollment
replace outcome = 22 if eff == "Enroll in selective college" //Selective College enrollment
replace outcome = 23 if eff == "4 year college enrollment" | eff == "Enrolled  4 year college" | eff == "Likelihood of enrolling in 4 year college" //4 year College enrollment
replace outcome = 24 if eff == "Attended college" //College attendance
replace outcome = 25 if eff == "Attended 4 year college" | eff == "Ever attended 4 year college" //4 year College attendance
replace outcome = 26 if eff == "Ever attended selective 4 year college" //selective 4 year College attendance
replace outcome = 27 if eff == "Earned a degree from 4 year college" | eff == "Graduated 4 year college" | eff=="Higher education degree" //4 year College graduation
replace outcome = 28 if eff == "Earned a degree from selective 4 year college" //selective 4 year College graduation
replace outcome = 29 if eff == "college entrance score highest than lowest cutoff (Qualify for college)"  //Qualify for college

replace exclude = 1 if outcome == 23 & EvaluationName == "Dobbie and Fryer (2014)" //Graduation is preferred to Enrollment
replace exclude = 1 if outcome == 25 & EvaluationName == "Deming et al (2014)" 
replace exclude = 1 if outcome == 7 & EvaluationName == "Abdulkadiroglu et al (2014)"  
*replace exclude = 1 if outcome == 25 & EvaluationName == "angrist" // if using charter then correct since math/reading are a probability? also dupped university with as the 3 previous.  
 
*replace outcome = 30 if outcome == 7 | outcome == 23 | outcome == 25 | outcome==27

*Employment
replace outcome = 101 if eff == "employed" | eff == "Formal Employment"

*Earnings
replace outcome = 102 if eff == "Average earnings ($/year of charter)" | eff == "log annual income" | eff == "Annual Earnings"

*Crime
replace outcome = 103 if eff == "All Non traffic arrests" | eff == "Arrested by police in past year" | eff == "Ever incarcerated (male)" | eff == ""
 
*Pregnancy
replace outcome = 104 if eff == "Ever pregnant (female)" | eff=="any children"

*Health	
replace outcome = 105 if eff == "Health Index"

label define outcome 1 "Math" 2 "Language" 3 "Overall" 7 "Took High Stakes Exam" 23 "Enrolled 4 year college" 27 "Graduated from 4 year college"
label values outcome outcome


drop if eff == "Probability  (average)" | eff == "PSAT score (average)" | eff == "Years of education" | eff == "2. Reading"

drop Concatenate

save "$z/evaluations_effects.dta", replace

use  "$z/evaluations_effects.dta", clear
* INITIAL CLEANING - YOU WILL NOT NEED TO DO IT

drop if PaperID ==. 
*keep if Include1ifYES==1



* THIS IS THE LIST OF VARIABLES THAT YOU WILL NEED TO HAVE

keep PaperID EvaluationName EffectID Grades Population FollowupID ITT1yes eff outcome N coef se mark exclude country




rename EvaluationName evaluation
rename Grades grade
rename Population population
rename FollowupID followup
rename ITT1yes itt
rename N n
rename EffectID design
destring n, force replace 
format %8s population


		
* ARRANGE OUTCOME VARIABLE
tab   eff outcome
tab  outcome, mi 

capture label drop outcome
label define outcome 1 "Math" 2 "Language" 3 "Average" /*LABEL "AVERAGE" THE SUMMARY TEST SCORE REPORTED IN THE PAPER*/
label values outcome outcome

drop eff


destring followup, force replace


tab followup, mi




* GENERATE SUBSAMPLE IDENTIFIER

tostring followup, gen (follouwup_str)
gen subsample = "flp: "+ follouwup_str + " pop: " + population + " G: " + grade + " Cout: " + country
 
drop follouwup_str


//keep if followup==1
drop if exclude==1


* PRIORIZATION OF ITT ESTIMATES 
bysort evaluation  outcome subsample: egen aux_itt=min(itt)
tab aux_itt
drop if aux_itt==0 & itt==1 //drop TOT if we have ITT for the same evaluation and outcome
drop aux_itt 
* drop itt




* KEEP ONLY THE FIRST FOLLOW UP




* REMOVE FOLLOW-UP IDENTIFIER FROM SUBSAMPLE VARIABLE
replace subsample = subinstr(subsample, "flp: 1 ","",.) 

drop followup



* SAVE DATASET WITH THE EFFECTS-LEVEL DATA
save "$z/meta_effects.dta", replace









	* II. ARRANGE EVALUATION LEVEL DATA 
	import excel "$z/Dataset.xlsx", sheet("7. Evaluations") firstrow clear


* INITIAL CLEANING - YOU WILL NOT NEED TO DO IT

cap drop if PaperID ==. 


rename Concatenate concat
rename Country country
rename Yearofstartofevaluation year
rename Implementer implementer
rename Evaluationdesign design
rename EvaluationName evaluation

keep concat country year implementer design evaluation effect

capture replace year="." if year=="-"
destring year, replace


drop if design == "lottery-voucher"

sort concat




 
* SAVE DATA SET WITH EVALUATION-LEVEL DATA

sort concat


save "$z/meta_eval.dta", replace



* III. MERGE EFFECTS AND EVALUATIONS 

use PaperID evaluation itt n coef se outcome subsample grade population country design using "$z/meta_effects.dta", clear
merge m:1 evaluation using "$z/meta_eval.dta", keepusing(evaluation year effect concat)

tab _merge

* HERE WE DROP SOME EVALUATIONS BECAUSE THE EFFECT SIZES DID NOT HAVE ALL THE NECESSARY DATA REPORTED

keep if _merge==3  
drop _merge


drop concat


order evaluation country year grade population subsample n itt outcome coef se

save "$z/evaluations_effects.dta", replace
	