* ANALYSIS OF EFFECTS SIZES TO PRODUCE A META-ANALYSIS OF EDUCATIONAL INTERVENTIONS.
* IT USES A PROCEDURE SIMILAR TO THE ONE USED IN THE SKILLSBANK (AS OF 20-FEB-2019).
* THERE ARE 3 DO FILES INVOLVED IN THIS ANALYSIS. 


* THIS IS THE SECOND DO FILE.
* THIS DO FILE, CALLED AGGREGATE.DO, AGGREATE THE DATA SO THAT WE END UP WITH A SUMMARY EFFECT FOR EACH EVALUATION



clear all
set more off

foreach type in "preferred" "elite" "all" /*"charter"*/  {
	foreach outcome in "3" /*"27" "102" "103" "101" "102" "103" "104" "105"*/ {

		* 1. READ THE DATA SET CONTAINING ONE EFFECT SIZE (AND A STANDARD ERROR) PER EVALUATION 
		
		if "`type'" == "all" { 
			use "$z/evaluations_preferred.dta", clear
			append using "$z/evaluations_elite.dta"
			}
		
		if "`type'" != "all" use "$z/evaluations_`type'.dta", clear
		
		sort coef

		keep if outcome==`outcome'
		
		* RUN A RANDOM EFFECTS META-REGRESSION USING A METHOD OF MOMENTS TO ESTIMATE THE BETWEEN-STUDY VARIANCE
		* metareg coef,wsse(se) mm

		* RUN A RANDOM EFFECTS META-REGRESSION USING MAXIMUM LIKELIHOOD TO ESTIMATE THE BETWEEN-STUDY VARIANCE
		
		if _N>1 { //N>=2 then run meta
		metareg coef,wsse(se) mm z
		mat res = r(table)
		* GET RELEVANT STATISTICS IN CASE WE WANT TO EXPORT THEM
		local b = res[1,1]
		local s = res[2,1]
		local z = res[3,1]
		local tau = sqrt(e(tau2)) 
		
		//Confidence interval
		local cl = res[5,1] //Confidence interval lower
		local cu = res[6,1] //Confidence interval upper
		
		//Prediction interval
		local pu = `b' + `z'*sqrt(`tau'^2 + `s'^2)
		local pl = `b' - `z'*sqrt(`tau'^2 + `s'^2)
		
		di "`pl' - `pu'"
		di "`cl' - `cu'"
	
		mat b = `b'
		mat s = sqrt(`tau'^2 + `s'^2)
		mat ll = `pl'
		mat ul = `pu'
	
		}
		
		*Better have missing if N=1 also
		/*
		if _N==1 { //in case the metareg cannot be done
			local coef=coef in 1
			mat b = (`coef')
			local s=se^2 in 1 //So we use the same notation (of ^0.5 afterwards in dofile 4)
			mat s = (`s')
			}
		*/	
		if _N<=1 { //In case no observations
			mat b = (.)
			mat s = (.)
			mat ll = (.)
			mat ul = (.)
			}
		* GENERATE A META-ANALYSIS GRAPH

		* WILL KEEP JUST 20 OBSERVATIONS SO THAT THE GRAPH LOOKS GOOD

		* SORT EVALUATIONS IN THE GRAPH FROM THE MOST PRECISE TO THE LEAST PRECISE

		*sort se 

		list evaluation coef se, sep(100)
		
		mat b_`outcome'_`type' = b
		mat s_`outcome'_`type' = s
		mat ll_`outcome'_`type' = ll
		mat ul_`outcome'_`type' = ul		
			
		*metan coef se, random label (namevar=evaluation) xlabel (-1, -.5, 0, .5, 1) boxsca(1)  name(g`i', replace) graphregion(fcolor(white)) graphregion(color(white))
		*graph save "$g\g`i'.gph" , replace	
		}
	}
		
		
	
