foreach type in "preferred" "elite" "all" /*"charter"*/ {
	
	if "`type'" != "all" { //only order for preferred and elite.
		
		/*
		*Overall Score is used for outcome 3
		use "$z/evaluations_`type'.dta", clear
		replace coef = . if outcome!=3
		sort coef
		sort evaluation coef
		by evaluation : keep if _n==1
		sort coef evaluation
		*replace evaluation = subinstr(evaluation," ","_",.)
		*replace evaluation = subinstr(evaluation,"Pop_Eleches_and_Urquiola","PE&U",.)
		*replace evaluation = subinstr(evaluation,"Abdulkadiroglu","Abdul",.)
		*/
	
		*Overall Score is used for outcome 3
		use "$z/evaluations_`type'.dta", clear
		bys id : keep if _n==1
		sort id1 id
		*replace evaluation = subinstr(evaluation," ","_",.)
		*replace evaluation = subinstr(evaluation,"Pop_Eleches_and_Urquiola","PE&U",.)
		*replace 
		
		local i 1
		while `i'<=_N {
			local eval = id in `i'
			local eval_order_`type' `eval_order_`type'' `eval'
			local ++ i
			}
			
		di "`eval_order_`type''" 
		}
		
	if "`type'" == "all" { //only order for preferred and elite.
		
		/*
		*Overall Score is used for outcome 3
		use "$z/evaluations_`type'.dta", clear
		replace coef = . if outcome!=3
		sort coef
		sort evaluation coef
		by evaluation : keep if _n==1
		sort coef evaluation
		*replace evaluation = subinstr(evaluation," ","_",.)
		*replace evaluation = subinstr(evaluation,"Pop_Eleches_and_Urquiola","PE&U",.)
		*replace evaluation = subinstr(evaluation,"Abdulkadiroglu","Abdul",.)
		*/
	
		*Overall Score is used for outcome 3
		use "$z/evaluations_preferred.dta", clear
		append using "$z\evaluations_elite.dta"
		bys id : keep if _n==1
		sort id1 id
		*replace evaluation = subinstr(evaluation," ","_",.)
		*replace evaluation = subinstr(evaluation,"Pop_Eleches_and_Urquiola","PE&U",.)
		*replace 
		
		local i 1
		while `i'<=_N {
			local eval = id in `i'
			local eval_order_`type' `eval_order_`type'' `eval'
			local ++ i
			}
			
		di "`eval_order_`type''" 
		}	
		

			
	*Number of evaluations
	foreach outcome in "3" /*"27" "102" "103" "102" "103" "104" "105"*/  {
		clear
		*if (`outcome' !=3) & "`type'"=="all" continue //If not an overall outcome don't do for "all"
		
		if "`type'"!="all" use "$z/evaluations_`type'.dta", clear // Only load database if not for overall
		if "`type'"=="all" {
			use "$z\evaluations_preferred.dta", clear
			append using "$z\evaluations_elite.dta"
			}
		*if `outcome' < 100 keep if coef!=. & outcome < 100
		*if `outcome' > 100 keep if coef!=. & outcome > 100
		
		if `outcome' == 3 local out_`outcome' = "Test Scores" //"Test Scores"
		if `outcome' == 5 local out_`outcome' = "Graduated HS" //"Graduated High School"
		if `outcome' == 7 local out_`outcome' = "Took College Entrance" //"Took High Stakes"
		if `outcome' == 27 local out_`outcome' = "University Degree"
		if `outcome' == 30 local out_`outcome' = "Tertiary"
		if `outcome' == 101 local out_`outcome' = "Employment"
		if `outcome' == 102 local out_`outcome' = "Earnings"
		if `outcome' == 103 local out_`outcome' = "Crime"
		if `outcome' == 104 local out_`outcome' = "Teen Pregnancy"
		if `outcome' == 105 local out_`outcome' = "Health"
		
		if "`type'" == "preferred" local title = "Preferred School"
		if "`type'" == "elite" local title = "Elite School"
		if "`type'" == "charter" local title = "Charter School"
		
		*if `outcome' == 3 { //Overall only for test scores
			*clear
			preserve
			*local type = "all"
			*local outcome = 3
				local coef_overall_`outcome' = round(b_`outcome'_`type'[1,1], 0.00001)
				local se_overall_`outcome' = round(s_`outcome'_`type'[1,1], 0.00001)
				local ll_overall_`outcome' = round(ll_`outcome'_`type'[1,1], 0.00001)
				local ul_overall_`outcome' = round(ul_`outcome'_`type'[1,1], 0.00001)
				
				clear
				set obs 1
				gen id = "overall_`type'"
				gen outcome = `outcome'
				gen coef = `coef_overall_`outcome''
				gen se = `se_overall_`outcome''
				gen ll95 = `ll_overall_`outcome''
				gen ul95 = `ul_overall_`outcome''
				tempfile overall_`outcome'
				save `overall_`outcome'', replace
			restore
			
			*}
		if "`type'" == "all" append using `overall_`outcome''	//Only  in all?
		
		*Confidence Interval
		*captu drop ll95 ul95
		capture gen ll95=.
		capture gen ul95=.
		replace ll95=coef-1.96*se if ll95==. //For metareg is the result of regression. For the rest is 1.96 for 95% confidence interval
		replace ul95=coef+1.96*se if ul95==.
		
		

		*replace evaluation = subinstr(evaluation," ","_",.)
		*replace evaluation = subinstr(evaluation,"Pop_Eleches_and_Urquiola","PE&U",.)
		*replace evaluation = subinstr(evaluation,"Abdulkadiroglu","Abdul",.)
		distinct id
		matrix B = J(`r(ndistinct)',3,.)

		local rownames
		levelsof id, local(id)	   
		foreach eval of local id {
			local rownames `rownames' `eval'
			}
			   
		matrix colnames B = coef ll95 ul95
		matrix rownames B = `rownames'
				 
		local i 0
		local B_`outcome' = 0
		foreach eval of local id {
			local ++ i
			preserve
			keep if id == "`eval'" & outcome == `outcome'
		
			*Keep coefficients and confidence intervals.
				local coef = .
				local ll95 = . 
				local ul95 = .
				
			if _N>0 {
				local B_`outcome' = 1 //There is evaluations (for xline(0) or not)
				local coef = coef
				local ll95 = ll95
				local ul95 = ul95
				}
				
			restore
			matrix B[`i',1] = `coef', `ll95', `ul95'
			}
		matrix list B
		mat B_`type'_`outcome' = B
		}
	}
	/*
	foreach outcome in "3" "5" "7" "27" "102" "103" "104" "105"  {
		if `outcome' == 3 mat B_`outcome' =  B_preferred_`outcome' \ B_elite_`outcome' \ B_all_`outcome'
		if `outcome' != 3 mat B_`outcome' =  B_preferred_`outcome' \ B_elite_`outcome'
		}
	*/
	di 	"`eval_order_preferred'"
	di 	"`eval_order_elite'"
	di	"`eval_order_all'"
	
local type = "all"
	
if "`type'"!="all" coefplot 	(matrix(B_preferred_3[,1]), ci((B_preferred_3[,2] B_preferred_3[,3])) ciopts(lcolor(gs0)) mcolor(gs0) msymbol(o) label("Preferred")) (matrix(B_elite_3[,1]), ci((B_elite_3[,2] B_elite_3[,3])) ciopts(lcolor(gs0)  lpattern(dash)) mcolor(gs0) msymbol(oh) label("Elite")) (matrix(B_all_3[,1]), ci((B_all_3[,2] B_all_3[,3])) ciopts(lcolor(gs0)) mcolor(gs0) msymbol(x) mlcolor(gs0) label("Overall")), bylabel("`out_3'")  || ///
				, byopts(row(1) xrescale)  order(`eval_order_preferred' `eval_order_elite' . overall)
				

if "`type'"=="all" coefplot  (matrix(B_all_3[,1]), ci((B_all_3[,2] B_all_3[,3])) ciopts(lcolor(gs0)) mcolor(gs0) msymbol(x) mlcolor(gs0) label("Overall")), bylabel("`out_3'")  || ///
				, byopts(row(1) xrescale)  order(`eval_order_all' . overall)
								
				
				*(matrix(B_preferred_27[,1]), ci((B_preferred_27[,2] B_preferred_27[,3])) ciopts(lcolor(gs0)) mcolor(gs0) msymbol(o) label("Preferred")) (matrix(B_elite_27[,1]), ci((B_elite_27[,2] B_elite_27[,3])) ciopts(lcolor(gs0)  lpattern(dash)) mcolor(gs0) msymbol(oh) label("Elite")) (matrix(B_all_27[,1]), ci((B_all_27[,2] B_all_27[,3])) ciopts(lcolor(gs0)) mcolor(gs0) msymbol(x) mlcolor(gs0) label("Overall")), bylabel("`out_27'") || ///
				*(matrix(B_preferred_102[,1]), ci((B_preferred_102[,2] B_preferred_102[,3])) ciopts(lcolor(gs0)) mcolor(gs0) msymbol(o) label("Preferred")) (matrix(B_elite_102[,1]), ci((B_elite_102[,2] B_elite_102[,3])) ciopts(lcolor(gs0)  lpattern(dash)) mcolor(gs0) msymbol(oh) label("Elite")) (matrix(B_all_102[,1]), ci((B_all_102[,2] B_all_102[,3])) ciopts(lcolor(gs0)) mcolor(gs0) msymbol(x) mlcolor(gs0) label("Overall")), bylabel("`out_102'") || ///
				
				*, byopts(row(1) xrescale)  order(`eval_order_preferred' overall_preferred . `eval_order_elite' overall_elite . overall)
				*, byopts(row(1) xrescale)  order(`eval_order_preferred' . `eval_order_elite' . overall)

*(matrix(B_preferred_103[,1]), ci((B_preferred_103[,2] B_preferred_103[,3])) ciopts(lcolor(gs0)) mcolor(gs0) msymbol(o) label("Preferred")) (matrix(B_elite_103[,1]), ci((B_elite_103[,2] B_elite_103[,3])) ciopts(lcolor(gs0)  lpattern(dash)) mcolor(gs0) msymbol(oh) label("Elite")) (matrix(B_all_103[,1]), ci((B_all_103[,2] B_all_103[,3])) ciopts(lcolor(gs0)) mcolor(gs0) msymbol(x) mlcolor(gs0) label("Overall")), bylabel("`out_103'") || ///
								
				addplot: , xline(0) norescaling
				*addplot 2: , xline(0) norescaling
				*addplot 3: , xline(0) norescaling
				*addplot 4: , xline(0) norescaling
	
	/*
	 coefplot 	(matrix(B_preferred_3[,1]), ci((B_preferred_3[,2] B_preferred_3[,3])) ciopts(lcolor(gs0)) mcolor(gs0)) (matrix(B_elite_3[,1]), ci((B_elite_3[,2] B_elite_3[,3])) ciopts(lcolor(gs0)  lpattern(dash)) mcolor(gs0) mlcolor(gs0)) (matrix(B_all_3[,1]), ci((B_all_3[,2] B_all_3[,3])) ciopts(lcolor(gs0)) mcolor(gs0) msymbol(x) mlcolor(gs0)), bylabel("`out_3'") || ///
				(matrix(B_preferred_5[,1]), ci((B_preferred_5[,2] B_preferred_5[,3])) ciopts(lcolor(gs0)) mcolor(gs0)) (matrix(B_elite_5[,1]), ci((B_elite_5[,2] B_elite_5[,3])) ciopts(lcolor(gs0)  lpattern(dash)) mcolor(gs0) mlcolor(gs0)) (matrix(B_all_5[,1]), ci((B_all_5[,2] B_all_5[,3])) ciopts(lcolor(gs0)) mcolor(gs0) msymbol(x) mlcolor(gs0)), bylabel("`out_5'") || ///
				(matrix(B_preferred_7[,1]), ci((B_preferred_7[,2] B_preferred_7[,3])) ciopts(lcolor(gs0)) mcolor(gs0)) (matrix(B_elite_7[,1]), ci((B_elite_7[,2] B_elite_7[,3])) ciopts(lcolor(gs0)  lpattern(dash)) mcolor(gs0) mlcolor(gs0)) (matrix(B_all_7[,1]), ci((B_all_7[,2] B_all_7[,3])) ciopts(lcolor(gs0)) mcolor(gs0) msymbol(x) mlcolor(gs0)), bylabel("`out_7'") || ///
				(matrix(B_preferred_27[,1]), ci((B_preferred_27[,2] B_preferred_27[,3])) ciopts(lcolor(gs0)) mcolor(gs0)) (matrix(B_elite_27[,1]), ci((B_elite_27[,2] B_elite_27[,3])) ciopts(lcolor(gs0)  lpattern(dash)) mcolor(gs0) mlcolor(gs0)) (matrix(B_all_27[,1]), ci((B_all_27[,2] B_all_27[,3])) ciopts(lcolor(gs0)) mcolor(gs0) msymbol(x) mlcolor(gs0)), bylabel("`out_27'") || ///
				, byopts(row(1) xrescale) order(`eval_order_preferred' overall_preferred . `eval_order_elite' overall_elite . overall)
				
				addplot 1: , xline(0) norescaling
				addplot 2: , xline(0) norescaling
				addplot 3: , xline(0) norescaling
				addplot 4: , xline(0) norescaling
*/
					
/*
	
*/	
				
				
				
				/*
				(matrix(A[,1]), ci((A[,2] A[,3])) ciopts(lcolor(gs0)) mcolor(gs0) label("Preferred")) (matrix(B[,1]), ci((B[,2] B[,3])) ciopts(lcolor(gs0)  lpattern(dash)) mcolor(gs0) mlcolor(gs0) label("Elite")) (matrix(C[,1]), ci((C[,2] C[,3])) ciopts(lcolor(gs0)) mcolor(gs0) msymbol(x) mlcolor(gs0) label("Overall")) || ///
				(matrix(A[,1]), ci((A[,2] A[,3])) ciopts(lcolor(gs0)) mcolor(gs0) label("Preferred")) (matrix(B[,1]), ci((B[,2] B[,3])) ciopts(lcolor(gs0)  lpattern(dash)) mcolor(gs0) mlcolor(gs0) label("Elite")) (matrix(C[,1]), ci((C[,2] C[,3])) ciopts(lcolor(gs0)) mcolor(gs0) msymbol(x) mlcolor(gs0) label("Overall")) || ///
				(matrix(A[,1]), ci((A[,2] A[,3])) ciopts(lcolor(gs0)) mcolor(gs0) label("Preferred")) (matrix(B[,1]), ci((B[,2] B[,3])) ciopts(lcolor(gs0)  lpattern(dash)) mcolor(gs0) mlcolor(gs0) label("Elite")) (matrix(C[,1]), ci((C[,2] C[,3])) ciopts(lcolor(gs0)) mcolor(gs0) msymbol(x) mlcolor(gs0) label("Overall")) || ///
				 , order([1a] [1b] [2] [3] [8] [9] [10] [12] [13a] [14] [16] [18] overall_preferred . [4] [5] [6] [7] [11] [13b] [15] [17] overall_elite . overall)
				 
	
	coefplot 	matrix(B_3[,1]), ci((B_3[,2] B_3[,3])) bylabel("`out_3'") || ///
				matrix(B_5[,1]), ci((B_5[,2] B_5[,3])) bylabel("`out_5'") || ///
				matrix(B_7[,1]), ci((B_7[,2] B_7[,3])) bylabel("`out_7'") || ///
				matrix(B_27[,1]), ci((B_27[,2] B_27[,3])) bylabel("`out_27'") || ///
				, byopts(row(1) xrescale)  order(`eval_order_preferred' overall_preferred . `eval_order_elite' overall_elite . overall)
				
				if `B_3' == 1 addplot 1: , xline(0) norescaling
				if `B_5' == 1 addplot 2: , xline(0) norescaling
				if `B_7' == 1 addplot 3: , xline(0) norescaling
				if `B_27' == 1 addplot 4: , xline(0) norescaling
								
				graph save "$g\g1.gph" , replace
				
	coefplot 	matrix(B_102[,1]), ci((B_102[,2] B_102[,3])) bylabel("`out_102'") || ///
				matrix(B_103[,1]), ci((B_103[,2] B_103[,3])) bylabel("`out_103'") || ///
				matrix(B_104[,1]), ci((B_104[,2] B_104[,3])) bylabel("`out_104'") || ///
				matrix(B_105[,1]), ci((B_105[,2] B_105[,3])) bylabel("`out_105'") || ///
				, byopts(row(1) xrescale) order(`eval_order')
				
				if `B_102' == 1 addplot 1: , xline(0) norescaling
				if `B_103' == 1 addplot 2: , xline(0) norescaling
				if `B_104' == 1 addplot 3: , xline(0) norescaling
				if `B_105' == 1 addplot 4: , xline(0) norescaling
				
				graph save "$g\g2.gph" , replace

				
	graph combine "$g\g1.gph" "$g\g2.gph", col(1) title("`title'")
	*/
	graph save "$g\Figure1_final.gph" , replace
	capture qui graph export "$g\Figure1_final.png"
	
	
	
*graph use "$g\g_preferred.gph"
*graph use "$g\g_elite.gph"
*graph use "$g\g_charter.gph"	

